/*
		This is my AllegroGL test program.  This stuff is actually quite neat, and
		not as hard as I originally percieved it.
*/



float sqr( float n );

int game_over;
GLfloat fogColor[4]= {0.1f, 0.7f, 0.9f, 0.5f};          // Fog Color


volatile int game_timer = 0;
void inc_game_timer()
{
	game_timer++;
} END_OF_FUNCTION( inc_game_timer );


void init_camera()
{
	allegro_gl_begin();
		glMatrixMode (GL_PROJECTION);
		glLoadIdentity ();
		glFrustum (-1.0, 1.0, -1.0, 1.0, 1.0, 20.0);
		glMatrixMode (GL_MODELVIEW);
	allegro_gl_end();
}

void do_camera( int c )
{
	glLoadIdentity();

	if ( num_humans == 0 )
		glViewport( 0, 0, 640, 480 );
	else
		if ( num_humans == 1 )
			switch ( c )
			{
				case 0: 	glViewport( 0, 0, 640, 240 );
							break;
				case 1:	glViewport( 0, 240, 640, 240 );
							break;
			}
		else
			switch ( c )
			{
				case 0:	glViewport( 0, 0, 320, 240 );
							break;
				case 1:	glViewport( 0, 240, 320, 240 );
							break;
				case 2:	glViewport( 320, 240, 320, 240 );
							break;
				case 3:	glViewport( 320, 0, 320, 240 );
							break;
			}

	glRotatef( CAMERA_RX, 1, 0, 0 );
	glRotatef( camera[ c ].ry, 0, 1, 0 );
	glRotatef( camera[ c ].rz, 0, 0, 1 );
	glScalef( 0.1, 0.1, 0.1 );

	glTranslatef( camera[ c ].x, camera[ c ].y, camera[ c ].z );
}


void make_sound( int n, int x, int z )
{
	float sound_distance;
	float volume;

	sound_distance = sqr( tank[ 0 ].x - x) + sqr( tank[ 0 ].z  - z);

	if ( sound_distance <= sqr( HEARING_DISTANCE ) )
	{
		volume = 255 - ((sound_distance / sqr(HEARING_DISTANCE)) * 255);
		play_sample( sound[ n ].dat, volume, 128, 1000, 0 );
	}
}

void new_screen()
{
	allegro_gl_begin();

	// Clear the RGB buffer and the depth buffer
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

}

void end_screen()
{
	glFlush();

	allegro_gl_flip();
	allegro_gl_end();
}

//c is the camera #
void draw_screen( int c )
{
	int i;

	float r, g;
	int tanktexture;

	//Draw Tanks
	for ( i = 0; i < NUM_TANKS; i++ )
		if ( tank[ i ].life > 0 )
			if (  ( abs( tank[ i ].x - tank[ c ].x ) < SEEING_DISTANCE )
			   && ( abs( tank[ i ].z - tank[ c ].z ) < SEEING_DISTANCE ) )
			{
				do_camera( c );
				//Draw Tank
				glTranslatef( tank[ i ].x , tank[ i ].y, tank[ i ].z );
				glRotatef( tank[ i ].angle - 90, 0, 1, 0 );
				glRotatef( -90, 1, 0, 0 );

				glScalef( 0.7, 0.7, 0.7 );


				if ( i <= num_humans )
					tanktexture = glTexture[ 3 ];
				else
					tanktexture = glTexture[ 1 ];

				glBindTexture( GL_TEXTURE_2D, tanktexture );
				glCallList( glList[ MODEL_BODY ] );

				glBindTexture( GL_TEXTURE_2D, glTexture[ 2 ] );
				glCallList( glList[ MODEL_LTREAD ] );
				glCallList( glList[ MODEL_RTREAD ] );
				do_camera( c );
				//Draw Turret and Barrel
				glTranslatef( tank[ i ].turret_x , tank[ i ].y, tank[ i ].turret_z );
				glRotatef( tank[ i ].turret_angle - 90, 0, 1, 0 );
				glRotatef( -90, 1, 0, 0 );
				glScalef( 0.7, 0.7, 0.7 );

				glBindTexture( GL_TEXTURE_2D, tanktexture );
				glCallList( glList[ MODEL_TURRET ] );
				glCallList( glList[ MODEL_BARREL ] );

				glBindTexture( GL_TEXTURE_2D, 0 );
			}

	//Draw Bullets
	for ( i = 0; i < MAX_BULLETS; i++ )
		if ( bullet[ i ].life > 0 )
			if (  ( abs( bullet[ i ].x - tank[ c ].x ) < SEEING_DISTANCE )
			   && ( abs( bullet[ i ].z - tank[ c ].z ) < SEEING_DISTANCE ) )
			{
				do_camera( c );
				glTranslatef( bullet[ i ].x, BULLET_Y, bullet[ i ].z );
				glScalef( 1.0, 1.0, 1.0 );
				glBindTexture( GL_TEXTURE_2D, 0 );

				glColor3f( 0.5, 0.5, 0.3 );
				glCallList( glList[ MODEL_BULLET ] );
				glColor3f( 1,1,1 );
			}

	//Draw Particles
	for ( i = 0; i < MAX_PARTICLE; i++ )
		if ( particle[ i ].life > 0 )
			if (  ( abs( particle[ i ].x - tank[ c ].x ) < SEEING_DISTANCE )
			   && ( abs( particle[ i ].z - tank[ c ].z ) < SEEING_DISTANCE ) )
			{
				do_camera( c );
				glTranslatef( particle[ i ].x, particle[ i ].y, particle[ i ].z );
				glRotatef( particle[ i ].rx, 1, 0, 0 );
				glRotatef( particle[ i ].ry, 0, 1, 0 );
				glRotatef( particle[ i ].rz, 0, 0, 1 );
				glBindTexture( GL_TEXTURE_2D, 0 );

				glColor3f( particle[ i ].r, particle[ i ].g,particle[ i ].b );
				glBegin( GL_TRIANGLES);
					glVertex3f( 0.0, 0.2, 0.0 );
					glVertex3f( 0.2,-0.2, 0.1 );
					glVertex3f(-0.2,-0.2,-0.1 );
				glEnd();
				glColor3f( 1.0, 1.0, 1.0 );
			}

	//Draw Trees
	for ( i = 0; i < NUM_TREES; i++ )
		if ( ( abs( tree[ i ].x - tank[ c ].x ) < SEEING_DISTANCE )
			&&( abs( tree[ i ].z - tank[ c ].z ) < SEEING_DISTANCE ) )
		{
			do_camera( c );
			glTranslatef( tree[ i ].x, GROUND_Y, tree[ i ].z );
			glBindTexture( GL_TEXTURE_2D, 0 );
			glColor3f( 0.0, 0.5, 0.0 );
			glCallList( glList[ MODEL_TREE ] );
			glColor3f( 1.0, 1.0, 1.0 );
		}

	//Draw Ground
	do_camera( c );
	glBindTexture( GL_TEXTURE_2D, glTexture[ 0 ] );

	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

	glBegin( GL_QUADS );
		glNormal3f( 0, 2, 0 );
		glTexCoord2f( 0.0f, 		0.0f );		glVertex3f( -1000, GROUND_Y, -1000 );
		glTexCoord2f( 200.0f, 	0.0f );		glVertex3f(  1000, GROUND_Y, -1000 );
		glTexCoord2f( 200.0f, 	200.0f );	glVertex3f(  1000, GROUND_Y,  1000 );
		glTexCoord2f( 0.0f, 		200.0f );	glVertex3f( -1000, GROUND_Y,  1000 );
	glEnd();

	//Draw Boundry Walls
	do_camera( c );
	glBindTexture( GL_TEXTURE_2D, glTexture[ 1 ] );
	glBegin( GL_QUADS );
		if ( abs( -BOUNDRY_Z - tank[ c ].z ) < SEEING_DISTANCE )
		{
			glNormal3f( 0, 0, 0 );
			glTexCoord2f( 10,  0 );					glVertex3f( -BOUNDRY_X, 0, 			-BOUNDRY_Z );
			glTexCoord2f(  0,  0 );					glVertex3f(  BOUNDRY_X, 0, 			-BOUNDRY_Z );
			glTexCoord2f(  0, 10 );					glVertex3f(  BOUNDRY_X, GROUND_Y,	-BOUNDRY_Z );
			glTexCoord2f( 10, 10 );					glVertex3f( -BOUNDRY_X, GROUND_Y, 	-BOUNDRY_Z );
		}
		if ( abs( BOUNDRY_Z - tank[ c ].z ) < SEEING_DISTANCE )
		{
			glNormal3f( 0, 0, 0 );
			glTexCoord2f( 10,  0 );					glVertex3f( -BOUNDRY_X, 0, 			 BOUNDRY_Z );
			glTexCoord2f(  0,  0 );					glVertex3f(  BOUNDRY_X, 0, 			 BOUNDRY_Z );
			glTexCoord2f(  0, 10 );					glVertex3f(  BOUNDRY_X, GROUND_Y,	 BOUNDRY_Z );
			glTexCoord2f( 10, 10 );					glVertex3f( -BOUNDRY_X, GROUND_Y, 	 BOUNDRY_Z );
		}

		if ( abs( -BOUNDRY_X - tank[ c ].x ) < SEEING_DISTANCE )
		{
			glNormal3f( 0, 0, 0 );
			glTexCoord2f( 10,  0 );					glVertex3f( -BOUNDRY_X, 0, 			-BOUNDRY_Z );
			glTexCoord2f(  0,  0 );					glVertex3f( -BOUNDRY_X, 0, 			 BOUNDRY_Z );
			glTexCoord2f(  0, 10 );					glVertex3f( -BOUNDRY_X, GROUND_Y,	 BOUNDRY_Z );
			glTexCoord2f( 10, 10 );					glVertex3f( -BOUNDRY_X, GROUND_Y, 	-BOUNDRY_Z );
		}
		if ( abs( BOUNDRY_X - tank[ c ].x ) < SEEING_DISTANCE )
		{
			glNormal3f( 0, 0, 0 );
			glTexCoord2f( 10,  0 );					glVertex3f(  BOUNDRY_X, 0, 			-BOUNDRY_Z );
			glTexCoord2f(  0,  0 );					glVertex3f(  BOUNDRY_X, 0, 			 BOUNDRY_Z );
			glTexCoord2f(  0, 10 );					glVertex3f(  BOUNDRY_X, GROUND_Y,	 BOUNDRY_Z );
			glTexCoord2f( 10, 10 );					glVertex3f(  BOUNDRY_X, GROUND_Y, 	-BOUNDRY_Z );
		}

	glEnd();

}


//c is the camera number
void move_camera( int c )
{
	camera[ c ].ry = -tank[ c ].turret_angle - 180;

	camera[ c ].x = -tank[ c ].x - sin( (-camera[ c ].ry * PI)/ 180 ) * CAMERA_DISTANCE;
	camera[ c ].z = -tank[ c ].z - cos( (-camera[ c ].ry * PI)/ 180 ) * CAMERA_DISTANCE;
	camera[ c ].y = -tank[ c ].y - CAMERA_Y_DISTANCE;
	camera[ c ].rx = CAMERA_RX;
}









//Tank Controlls
void move_tank_left( int tanknum )
{
	tank[ tanknum ].angle += ROTATE_SPEED;
}
void move_tank_right( int tanknum )
{
	tank[ tanknum ].angle -= ROTATE_SPEED;
}

void move_tank_forwards( int tank_num )
{
	tank[ tank_num ].vz = cos( (tank[ tank_num ].angle * PI) / 180) * TANK_SPEED;
	tank[ tank_num ].vx = sin( (tank[ tank_num ].angle * PI )/ 180) * TANK_SPEED;
}

void move_tank_backwards( int tank_num )
{
	tank[ tank_num ].vz = cos( (tank[ tank_num ].angle * PI) / 180) * -TANK_SPEED;
	tank[ tank_num ].vx = sin( (tank[ tank_num ].angle * PI )/ 180) * -TANK_SPEED;
}

void stop_tank( int tanknum )
{
	tank[ tanknum ].vx = 0;
	tank[ tanknum ].vz = 0;
}

void shoot_bullet( int tanknum )
{
	int i;

	//Fire a Bullet if the tank is ready to fire a bullet
	if ( tank[ tanknum].fire <= 0 )
	{
		//Find a bullet not in use
		for ( i = 0; bullet[ i ].life > 0; i++ );

		bullet[ i ].life = BULLET_LIFE;
		bullet[ i ].x = tank[ tanknum ].x + cos( ( -(tank[ tanknum ].turret_angle - 90) * PI) / 180) * (HIT_RADIUS + 0.1);
		bullet[ i ].z = tank[ tanknum ].z + sin( ( -(tank[ tanknum ].turret_angle - 90) * PI) / 180) * (HIT_RADIUS + 0.1);;
		bullet[ i ].vx = cos( ( -(tank[ tanknum ].turret_angle - 90) * PI) / 180) * BULLET_SPEED;
		bullet[ i ].vz = sin( ( -(tank[ tanknum ].turret_angle - 90) * PI) / 180) * BULLET_SPEED;


		//Reset the amount of time it takes for the tank to shoot again
		tank[ tanknum ].fire = TANK_FIRE;

		//Play the sound of this event
		make_sound( 1, tank[tanknum].x, tank[tanknum].z );

		//Bounce Turret Backwards a bit
		tank[ tanknum ].turret_bounce = TURRET_BOUNCING;
	}
}


int player_key( int p, int k )
{
	int retval = 0;
	if ( player[ p ].joy[ k ] )
		retval = poll_joystick_key( player[ p ].key[ k ] );
	else
		retval = key[ player[ p ].key[ k ] ];

	return retval;

}


void keyboard_input( int p )
{
	if ( player_key( p, 0 ) )
		move_tank_left( p );
	if ( player_key( p, 1 ) )
		move_tank_right( p );
	if ( player_key( p, 2 ) )
		move_tank_forwards( p );
	else
		if ( player_key( p, 3 ) )
			move_tank_backwards( p );
		else
			stop_tank( p );

	if ( player_key( p, 4 ) )
		tank[ p ].turret_angle += TURRET_SPEED;
	if ( player_key( p, 5 ) )
		tank[ p ].turret_angle -= TURRET_SPEED;
	if ( player_key( p, 6 ) )
		shoot_bullet( p );
}

void mouse_input( int p )
{
	int mx, my;

	if ( key[ player[ p ].key[ 0 ] ] )
		move_tank_left( p );
	if ( key[ player[ p ].key[ 1 ] ] )
		move_tank_right( p );
	if ( key[ player[ p ].key[ 2 ] ] )
		move_tank_forwards( p );
	else
		if ( key[ player[ p ].key[ 3 ] ] )
			move_tank_backwards( p );
		else
			stop_tank( p );

	get_mouse_mickeys( &mx, &my );
	tank[ p ].turret_angle -= mx;

	if ( mouse_b & 1 )
		shoot_bullet( p );
}




//User Input
//p is for a specific unit
void do_input( int p )
{

	if ( tank[ p ].life > 0 )
	{
		switch( player[ p ].input_type )
		{
			case 0:	keyboard_input( p );
						break;
			case 1:	mouse_input( p );
						break;
			case 2:	keyboard_input( p );
						break;
			case 3:	keyboard_input( p );
						break;
		}
	}
}

void do_function_keys()
{
	if ( key[ KEY_F12 ] )
		save_bmp( "screen.bmp", allegro_gl_screen, 0 );
	if ( key[ KEY_ESC ] )
		game_over = 1;
}


float sqr( float n )
{
	return (n * n);
}




void do_ai()
{
	int i;
	int r;

	float dx, dz;
	float dd;
	for ( i = num_humans + 1; i < NUM_TANKS; i++ )
		if ( tank[ i ].life > 0 )
		{
			r = (int)(rand()%100);
			if ( r < AI_TURN_LEFT_PERCENT )
				move_tank_left( i );
			else
				move_tank_right( i );


			//Find a random Target

			for ( r = (int)(rand()%NUM_TANKS); tank[ r ].life < 0; tank[ r ].life = (int)(rand()%NUM_TANKS ) );;

			if ( (int)(rand()%100) < AI_TURN_LEFT_PERCENT )
				tank[ i ].turret_angle++;
			else
				tank[ i ].turret_angle--;

				shoot_bullet( i );
				move_tank_forwards( i );
		}

}

void add_particles( int num, int x, int y, int z, int d_variance, float v_variance, int life, int l_variance )
{
	int i;
	int loop;

	int vv;

	for ( loop = 0; loop < num; loop++ )
	{
		//Find an empty particle
		for ( i = 0; particle[ i ].life > 0; i++ );
		particle[ i ].x = x + (rand()%(d_variance * 2) ) - d_variance;
		particle[ i ].y = y + (rand()%(d_variance * 2) ) - d_variance;
		particle[ i ].z = z + (rand()%(d_variance * 2) ) - d_variance;

		vv = (int)(v_variance * 100);
		particle[ i ].vx = rand()%(vv * 2);
		particle[ i ].vy = rand()%(vv * 5);
		particle[ i ].vz = rand()%(vv * 2);

		particle[ i ].vx -= vv;
		particle[ i ].vz -= vv;
		particle[ i ].vx /= 100;
		particle[ i ].vy /= 100;
		particle[ i ].vz /= 100;
		
		particle[ i ].life = life + ( (rand()%(l_variance * 2)) - l_variance);

		particle[ i ].vrx = (int)(rand()%720) - 360;
		particle[ i ].vry = (int)(rand()%720) - 360;
		particle[ i ].vrz = (int)(rand()%720) - 360;

		particle[ i ].r = rand()%75 + 25;
		particle[ i ].g = (rand()%((int)particle[ i ].r + 1) );
		particle[ i ].b = 0;
		particle[ i ].r /= 100;
    	particle[ i ].g /= 100;
		particle[ i ].b /= 100;

	}
}

void do_physics()
{
	float oldx, oldz;
	int i;
	int t;
	//Do Tank Physics
	for ( i = 0; i < NUM_TANKS; i++ )
	{
		oldx = tank[ i ].x;
		oldz = tank[ i ].z;

		tank[ i ].x += tank[ i ].vx;
		tank[ i ].z += tank[ i ].vz;

		//Reduce Tank Fire If Necessary
		if ( tank[ i ].fire > 0 )
			tank[ i ].fire--;

		if ( tank[ i ].x > BOUNDRY_X )
			tank[ i ].x = BOUNDRY_X;
		if ( tank[ i ].x < -BOUNDRY_X )
			tank[ i ].x = -BOUNDRY_X;
		if ( tank[ i ].z > BOUNDRY_Z )
			tank[ i ].z = BOUNDRY_Z;
		if ( tank[ i ].z < -BOUNDRY_Z )
			tank[ i ].z = -BOUNDRY_Z;

		//Do Turret Movement
		if ( tank[ i ].turret_bounce > 0 )
		{
			tank[ i ].turret_bounce -= TURRET_RECON;
			tank[ i ].turret_x = tank[ i ].x + cos( ((-tank[ i ].turret_angle + 90) * PI) / 180) * -tank[ i ].turret_bounce;
			tank[ i ].turret_z = tank[ i ].z + sin( ((-tank[ i ].turret_angle + 90) * PI )/ 180) * -tank[ i ].turret_bounce;

		}
		else
		{
			tank[ i ].turret_x = tank[ i ].x;
			tank[ i ].turret_z = tank[ i ].z;
		}

		//Check to see if the tank has hit a tree,  if it has move it to it's old position
		for ( t = 0; t <= NUM_TREES; t++ )
			if ( ( abs( tank[ i ].x - tree[ t ].x ) < 2 )
				&&( abs( tank[ i ].z - tree[ t ].z ) < 2 ) )
			{
				tank[ i ].x = oldx;
				tank[ i ].z = oldz;
			}
	}

	//Do Bullet Physics
	for ( i = 0; i < MAX_BULLETS; i++ )
		if ( bullet[ i ].life > 0 )
		{
			bullet[ i ].x += bullet[ i ].vx;
			bullet[ i ].z += bullet[ i ].vz;
			if ( bullet[ i ].life > 0 )
				bullet[ i ].life--;

			//Check Collision With Other Tanks
			for ( t = 0; t < NUM_TANKS; t++ )
				if ( tank[ t ].life > 0 )
					if ( sqr( tank[ t ].x - bullet[ i ].x ) + sqr( tank[ t ].z - bullet[ i ].z ) < HIT_RADIUS )
					{
						tank[ t ].life -= 1;
						bullet[ i ].life = 0;

						if ( tank[ t ].life == 0 )
						{
							//Play Explosion Sound
							make_sound( 0, tank[ t ].x, tank[ t ].z );
							//Count one more dead tank
							tanks_left--;
							//Make Particles
							add_particles( 150, tank[ t ].x, tank[ t ].y + 1, tank[ t ].z, 1.0,
												0.25, PART_LIFE, PART_LIFE_VARIANCE );
						}
						else
							make_sound( 2, tank[ t ].x, tank[ t ].z );
					}
			//Check Collision With Trees
			for ( t = 0; t <= NUM_TREES; t++ )
				if ( ( abs( bullet[ i ].x - tree[ t ].x ) < 2 )
					&&( abs( bullet[ i ].z - tree[ t ].z ) < 2 ) )
					bullet[ i ].life = 0;

		}

	//Do Particles
	for ( i = 0; i < MAX_PARTICLE; i++ )
		if ( particle[ i ].life > 0 )
		{
			particle[ i ].life--;
			particle[ i ].x += particle[ i ].vx;
			particle[ i ].y += particle[ i ].vy;
			particle[ i ].z += particle[ i ].vz;

			particle[ i ].rx += particle[ i ].vrx;
			particle[ i ].ry += particle[ i ].vry;
			particle[ i ].rz += particle[ i ].vrz;

			//Suspect to gravity
			particle[ i ].vy -= GRAVITY;
		}


	//If there is only one tank left standing then exit game and win
	if ( tanks_left <= 1 )
		game_over = 1;
}












void init_tanks()
{
	int i;
	tanks_left = NUM_TANKS;

	for ( i = 0; i < NUM_TANKS; i++ )
	{
		tank[ i ].x = (rand()%(BOUNDRY_X * 2)) - BOUNDRY_X;
		tank[ i ].z = (rand()%(BOUNDRY_Z * 2)) - BOUNDRY_Z;
		tank[ i ].y = TANK_Y;

		tank[ i ].vx = 0;
		tank[ i ].vz = 0;
		tank[ i ].life = TANK_LIFE;

		tank[ i ].angle = (rand()%360);
		tank[ i ].found_target = (rand()%NUM_TANKS);
	}

}

void handicap_tanks( int num_players )
{
	int i;
	for ( i = 0; i <= num_players; i++ )
		tank[ i ].life = HUMAN_TANK_LIFE;
}
void init_bullets()
{
	int i;
	for ( i = 0; i < MAX_BULLETS; i++ )
		bullet[ i ].life = 0;
}


void init_trees()
{
	int i;
	for ( i = 0; i < NUM_TREES; i++ )
	{
		tree[ i ].x = (int)(rand()%(BOUNDRY_X * 2) - BOUNDRY_X );
		tree[ i ].z = (int)(rand()%(BOUNDRY_X * 2) - BOUNDRY_X );
	}
}
int start_game( int num_players )
{
	int i;
	install_allegro_gl();

	allegro_gl_clear_settings();
	allegro_gl_set (AGL_COLOR_DEPTH, 32);
	allegro_gl_set (AGL_Z_DEPTH, 16);
	allegro_gl_set (AGL_FULLSCREEN, TRUE);
	allegro_gl_set (AGL_DOUBLEBUFFER, 1);
	allegro_gl_set (AGL_SUGGEST, AGL_COLOR_DEPTH | AGL_Z_DEPTH | AGL_DOUBLEBUFFER);

	set_color_depth (16);
	if (set_gfx_mode(GFX_OPENGL, 640, 480, 0, 0) < 0)
	{
		allegro_message ("Error setting graphics mode:\n%s\n", allegro_error);
		return -1;
	}


	allegro_gl_begin();
		glEnable(GL_TEXTURE_2D);                                                // Enable Texture Mapping
		glShadeModel(GL_SMOOTH);                                                // Enable Smooth Shading
		glClearDepth(1.0f);                                                     // Depth Buffer Setup
		glEnable(GL_DEPTH_TEST);                                                // Enables Depth Testing
		glDepthFunc(GL_LEQUAL);                                                 // The Type Of Depth Testing To Do
		glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);                      // Really Nice Perspective Calculations

		glClearColor(0.1f,0.7f,0.9f,1.0f);                      // Clear To The Color Of The Fog

		glFogi(GL_FOG_MODE, GL_LINEAR);               			  //Fog Mode
		glFogfv(GL_FOG_COLOR, fogColor);                        // Set Fog Color
		glFogf(GL_FOG_DENSITY, 0.01f);                          // How Dense Will The Fog Be
		glHint(GL_FOG_HINT, GL_DONT_CARE);                      // Fog Hint Value
		glFogf(GL_FOG_START, 3.0f);                             // Fog Start Depth
		glFogf(GL_FOG_END, 16.0f);                              // Fog End Depth
		glEnable(GL_FOG);
	allegro_gl_end();


	load_texture_set( "textures.dat", 4);
	init_camera();
	generate_lists();

	init_tanks();
	init_trees();
	handicap_tanks( num_players );
	num_humans = num_players;

	LOCK_VARIABLE( game_timer );
	LOCK_FUNCTION( inc_game_timer );
	install_int_ex( inc_game_timer, BPS_TO_TIMER( 60 ) );


	game_over = 0;
	while (!game_over )
	{
		while ( game_timer > 0 )
		{

			do_ai();

			do_physics();

			for ( i = 0; i <= num_players; i++ )
			{
				do_input( i );
				move_camera( i );
			}
			do_function_keys();

			game_timer--;
		}

		new_screen();
		for ( i = 0; i <= num_players; i++ )
			draw_screen( i );
		end_screen();
	}

	remove_int( inc_game_timer );
	remove_allegro_gl();

	set_color_depth( 16 );
	if ( set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0 ) < 0 )
	{
		printf( "Couldn't Init Graphics\n");
		return -1;
	}


}



